;*** Frekvencmeter s PIC 16F876/16F876A - S53MV - 05.05.2007 ***

;*** Uporaba portov - takt 20MHz ***
;analogni vhod RA0 - jakost signala preskalerja
;analogni vhod RA1 - jakost linearnega vhoda
;digitalni izhod RA2 - vrata FF J
;digitalni izhod RA3 - vrata FF /K
;digitalni vhod	RA4 - vklop linearnega vhoda
;digitalni vhod RA5 - vklop preskalerja /64
;digitalni izhodi RB0-7 - LCD HD44780 D0-7
;digitalni vhod RC0 - stevec /Q3 + vhod TIMER#1
;digitalni vhod RC1 - stevec /Q2
;digitalni vhod RC2 - stevec /Q1
;digitalni vhod RC3 - stevec /Q0
;digitalni vhod RC4 - stikalo #1 /100
;digitalni vhod RC5 - stikalo #2 /1
;digitalni izhod RC6 - LCD HD44780 RS
;digitalni izhod RC7 - LCD HD44780 E

;*** Uporaba RAMa ***
;20	CAKAJ40	zanka
;21	ZNAPIS, STEVIL racunanje
;22,23	PALICA, STEVIL racunanje
;24-28	MERIF odcitek 36 bitov
;29	MERIF zanka
;2A-2D	MERIF stara vrednost 32 bitov

;2F	DESET zanka
;30-33	DELI, DESET 32-bitno stevilo
;34	DELI ostanek
;35	DELI zanka
;36-3F	DESET desetisko stevilo

;70,71	PREKIN resi W in STATUS
;72	PREKIN naslednje stanje J/K
;73	PREKIN stevec prekinitev /64 ali /100
;74	PREKIN stevec prekinitev /1 ali /10 ali /100
;75	PREKIN glavni stevec prekinitev /10
;76,77	PREKIN gornja dva bajta stevca

;*** Zacetek programa, tocno 4 ukazi, sledi PREKIN ***
	LIST	P=16F876
	ORG	0
ZACETEK	CALL	INIPIC	;inicializacija PIC 16F876/16F876A
	CALL	INILCD	;inicializacija LCD HD44780
	CALL	ZNAPIS	;zacenti napis ob vklopu
	GOTO	ZANKA

;*** Prekinitve s frekvenco natancno 10kHz *** (70,71,72,73,74,75,76,77)
	ORG	4
PREKIN  MOVWF   70      ;resi W
	SWAPF   3,0     ;resi STATUS
	MOVWF   71
	NOP
	MOVLW	0B	;postavi TMR0 za takt 20MHz>>>$0B
	MOVWF	1
	MOVF	72,0	;postavi J/K vrata stevca
	MOVWF	5
	MOVLW	8	;izkljuci J/K
	MOVWF	72
	MOVF	75,0	;vklop/izklop J/K vrat stevca?
	BTFSC	3,2
	GOTO	PREKIN1
	MOVLW	4	;vkljuci J/K
	MOVWF	72
	DECFSZ	73,1	;stevec prekinitev /64 ali /100
	GOTO	PREKIN1
	MOVLW	40	;64
	BTFSS	5,5
	MOVLW	64	;100
	MOVWF	73
	DECFSZ	74,1	;stevec prekinitev /1 ali /10 ali /100
	GOTO	PREKIN1
	MOVLW	0A	;10
	BTFSS	7,4
	MOVLW	64	;100
	BTFSS	7,5
	MOVLW	1	;1
	MOVWF	74
	DECF	75,1	;glavni stevec prekinitev /10
PREKIN1	BTFSS	0C,0	;prenos stevca TMR1IF?
	GOTO	PREKIN2
	BCF	0C,0	;resetiraj TMR1IF
	INCF	76,1	;povecaj gornja dva bajta stevca 76,77
	BTFSC	3,2
	INCF	77,1
PREKIN2	BCF	0B,2	;resetiraj T0IF
	SWAPF	71,0	;obnovi STATUS
	MOVWF	3
	SWAPF	70,1	;obnovi W
	SWAPF	70,0
	RETFIE

;*** Inicializacija PIC 16F876/16F876A ***
INIPIC	CLRF	5	;zacetno stanje vrat
	CLRF	6
	CLRF	7
	BSF	3,5	;postavi PAGE1
	MOVLW	80	;OPTION: 1=/RBPU, 0=INTEDG, 0=T0CS, 0=T0SE, 0=PSA, 000=PS2-0
	MOVWF	1
	MOVLW	33	;vhodi RA0,1,4,5, izhodi RA2,3
	MOVWF	5
	MOVLW	0	;izhodi RB0-7
	MOVWF	6
	MOVLW	3F	;vhodi RC0-5, izhodi RC6,7
	MOVWF	7
	MOVLW	4	;ADCON1: 0=ADFM, 000, 0100=PCFG3-0
	MOVWF	1F
	BCF	3,5	;postavi PAGE0
	MOVLW	7	;T1CON: 00, 00=T1CKPS1-0, 0=T1OSCEN, 1=/T1SYNC, 1=TMR1CS, 1=TMR1ON
	MOVWF	10
	MOVLW	81	;ADCON0: 10=ADCS1-0, 000=CHS2-0, 0=GO/DONE, 0, 1=ADON 
	MOVWF	1F
	MOVLW	3	;reset 73,74,75
	MOVWF	73
	MOVWF	74
	MOVWF	75
	CLRF	1	;reset TMR0
	BSF	0B,5	;vkljuci T0IE
	BSF	0B,7	;vkljuci GIE
	RETURN

;*** Glavni program ***
ZANKA	CALL	IZPURA	;izpisi vodoravne crtice cakanja
	CALL	NACIN	;izpisi nacin delovanja MW, RF ali TTL
	CALL	JAKOST	;A/D pretvornik za jakost
	CALL	MERIF	;merjenje frekvence
	CALL	DESET	;pretvorba (25-28) binarno v (36-3F) desetisko
	CALL	FREQ	;izpis frekvence
	GOTO	ZANKA

;*** Izpis frekvence celi.decimalni ***
FREQ	MOVLW	081	;naslov LCD prva vrstica 2.znak
	CALL	UKAZ
	MOVLW	7	;10
	BTFSS	7,4
	MOVLW	6	;100
	BTFSS	7,5
	MOVLW	8	;1
	BTFSC	5,5	;preskaler vkljucen -1?
	ADDLW	0FF
	CALL	STEVIL	;izpisi (36-3F) desetisko, pika (W)
	MOVLW	20
	CALL	ZNAK
	MOVLW	6B	;"k"
	BTFSC	5,5	;preskaler vkljucen k>M?
	MOVLW	4D	;"M"
	CALL	ZNAK
	MOVLW	48	;"H"
	CALL	ZNAK
	MOVLW	7A	;"z'
	CALL	ZNAK
	RETURN

;*** Izpisi (36-3F) desetisko, pika (W) *** (21,22,23)
STEVIL	MOVWF	21
	MOVLW	0A	;zanka 10 ponavljanj
	MOVWF	22
	MOVLW	20	;zacetni presledki zamenjajo vodilne nicle
	MOVWF	23
	MOVLW	36
	MOVWF	4
STEVIL1	MOVLW	30
	MOVF	0,1	;zacne nenicelna stevilka?
	BTFSS	3,2
	MOVWF	23
	DECF	21,1	;prva izpisana nicla pred piko?
	BTFSC	3,2
	MOVWF	23
	MOVF	0,0
	ADDWF	23,0
	CALL	ZNAK
	MOVLW	2E	;izpis decimalne pike?
	MOVF	21,1
	BTFSC	3,2
	CALL	ZNAK
	INCF	4,1	;zanka po stevilkah
	DECFSZ	22,1
	GOTO	STEVIL1
	RETURN

;*** Pretvorba (25-28) binarno v (36-3F) desetisko *** (2F,36-3F)
DESET	MOVF	25,0	;prepisi v (30-33)
	MOVWF	30
	MOVF	26,0
	MOVWF	31
	MOVF	27,0
	MOVWF	32
	MOVF	28,0
	MOVWF	33
	MOVLW	0A	;zanka 10 ponavljanj
	MOVWF	2F
	MOVLW	3F
	MOVWF	4
DESET1	CALL	DELI	;deli (30-33) z 10 in ostanek v (34)
	MOVF	34,0
	MOVWF	0
	DECF	4,1
	DECFSZ	2F,1
	GOTO	DESET1
	RETURN

;*** Deli (30-33) z 10 in ostanek v (34) *** (30,31,32,33,34,35)
DELI	CLRF	34
	MOVLW	20
	MOVWF	35
DELI1	RLF	30,1	;premakni vse za 1bit v levo
	RLF	31,1
	RLF	32,1
	RLF	33,1
	RLF	34,1
	BCF	30,0
	MOVLW	0A	;odstej 10
	SUBWF	34,0
	BTFSS	3,0
	GOTO	DELI2
	MOVWF	34	;popravi ostanek in kvocient
	BSF	30,0
DELI2	DECFSZ	35,1
	GOTO	DELI1
	RETURN

;*** Merjenje frekvence v (25-28) *** (24,25,26,27,28,29,2A,2B,2C,2D)
MERIF	MOVF	75,0	;konec glavnega stevca?
	BTFSS	3,2
	RETURN
	CALL	CAKAJ40	;pocakaj 4ms do konca stetja
	COMF	7,0	;precitaj vse stevce
	MOVWF	24
	MOVF	0E,0	;TMR1L
	MOVWF	25
	MOVF	0F,0	;TMR1H
	MOVWF	26
	MOVF	76,0
	MOVWF	27
	MOVF	77,0
	MOVWF	28
	MOVLW	4	;premakni rezultat stiri mesta v levo
	MOVWF	29
MERIF1	RRF	24,1
	RLF	25,1
	RLF	26,1
	RLF	27,1
	RLF	28,1
	DECFSZ	29,1
	GOTO	MERIF1
	MOVF	25,0	;zamenjaj staro in novo med sabo
	MOVWF	24
	MOVF	2A,0
	MOVWF	25
	MOVF	24,0
	MOVWF	2A
	MOVF	26,0	;bajt 2
	MOVWF	24
	MOVF	2B,0
	MOVWF	26
	MOVF	24,0
	MOVWF	2B
	MOVF	27,0	;bajt 3
	MOVWF	24
	MOVF	2C,0
	MOVWF	27
	MOVF	24,0
	MOVWF	2C
	MOVF	28,0	;bajt 4
	MOVWF	24
	MOVF	2D,0
	MOVWF	28
	MOVF	24,0
	MOVWF	2D
	MOVF	25,0	;odstej novo-staro v (25-28)
	SUBWF	2A,0
	MOVWF	25
	BTFSC	3,0
	GOTO	MERIF2
	INCF	26,1
	BTFSS	3,2
	GOTO	MERIF2
	INCF	27,1
	BTFSC	3,2
	INCF	28,1
MERIF2	MOVF	26,0	;bajt 2
	SUBWF	2B,0
	MOVWF	26
	BTFSC	3,0
	GOTO	MERIF3
	INCF	27,1
	BTFSC	3,2
	INCF	28,1	
MERIF3	MOVF	27,0	;bajt 3
	SUBWF	2C,0
	MOVWF	27
	BTFSS	3,0
	INCF	28,1
	MOVF	28,0	;bajt 4
	SUBWF	2D,0
	MOVWF	28
	MOVLW	0A	;zacni novo meritev
	MOVWF	75
	RETURN

;*** Izpisi nacin delovanja MW, RF ali TTL ***
NACIN	MOVLW	0C1	;naslov LCD druga vrstica 2.znak
	CALL	UKAZ
	BTFSS	5,5	;izpis "MW:"?
	GOTO	NACIN1
	MOVLW	4D	;"M"
	CALL	ZNAK
	MOVLW	57	;"W"
	CALL	ZNAK
	MOVLW	3A	;":"
	CALL	ZNAK
	RETURN
NACIN1	BTFSS	5,4	;izpis "RF:"?
	GOTO	NACIN2
	MOVLW	52	;"R"
	CALL	ZNAK
	MOVLW	46	;"F"
	CALL	ZNAK
	MOVLW	3A	;":"
	CALL	ZNAK
	RETURN
NACIN2	MOVLW	54	;"T" - izpis "TTL"
	CALL	ZNAK
	MOVLW	54	;"T"
	CALL	ZNAK
	MOVLW	4C	;"L"
	CALL	ZNAK
	RETURN

;*** A/D pretvornik za jakost ***
JAKOST	BTFSC	1F,2	;pocakaj konec A/D pretvorbe?
	GOTO	JAKOST
	MOVF	5,0	;prikaz vkljucen MW ali RF?
	ANDLW	30
	BTFSC	3,2
	CLRF	1E
	RRF	1E,0	;obmocje jakosti 0-127
	ANDLW	7F
	CALL	PALICA
	MOVLW	85	;ADCON0: 10=ADCS1-0, 000=CHS2-0, 1=GO/DONE, 0, 1=ADON
	BTFSS	5,5
	MOVLW	8D	;ADCON0: 10=ADCS1-0, 001=CHS2-0, 1=GO/DONE, 0, 1=ADON
	MOVWF	1F
	RETURN

;*** Jakost (W) kot palica 12 znakov 0-36 crtic *** (22,23)
PALICA	MOVWF	22
	MOVLW	0C4	;naslov LCD druga vrstica 5.znak
	CALL	UKAZ
	MOVLW	0C	;zanka 12 znakov
	MOVWF	23
PALICA1 MOVLW	20	;praznina
	DECF	22,1
	BTFSC	22,7
	GOTO	PALICA2
	MOVLW	0	;ena crtica desno
	DECF	22,1
	BTFSC	22,7
	GOTO	PALICA2
	MOVLW	1	;dve crtici desno
	DECF	22,1
	BTFSC	22,7
	GOTO	PALICA2
	MOVLW	2	;tri crtice
PALICA2	CALL	ZNAK
	DECFSZ	23,1
	GOTO	PALICA1
	RETURN

;*** Izpisi vodoravne crtice cakanja ***
IZPURA	MOVLW	80	;naslov LCD zacetek prve vrstice
	CALL	UKAZ
	MOVF	75,0	;doloci gornji znak
	SUBLW	8A
	CALL	IZPURA1
	CALL	ZNAK
	MOVLW	0C0	;naslov LCD zacetek druge vrstice
	CALL	UKAZ
	MOVF	75,0	;doloci spodnji znak
	SUBLW	85
	CALL	IZPURA1
	CALL	ZNAK
	RETURN
IZPURA1 ADDLW	7F	;spodnja meja - presledek $20
	BTFSC	3,0
	GOTO	IZPURA2
	MOVLW	20
	RETURN
IZPURA2	ADDLW	0FC	;gornja meja - pet vodoravnih crtic $7
	BTFSC	3,0
	MOVLW	0
	ADDLW	7
	RETURN

;*** Zacetni napis ob vklopu *** (21)
ZNAPIS	MOVLW	80	;naslov LCD zacetek prve vrstice
	CALL	UKAZ
	MOVLW	46	;"F" - FrequencyCounter
	CALL	ZNAK
	MOVLW	72	;"r"
	CALL	ZNAK
	MOVLW	65	;"e"
	CALL	ZNAK
	MOVLW	71	;"q"
	CALL	ZNAK
	MOVLW	75	;"u"
	CALL	ZNAK
	MOVLW	65	;"e"
	CALL	ZNAK
	MOVLW	6E	;"n"
	CALL	ZNAK
	MOVLW	63	;"c"
	CALL	ZNAK
	MOVLW	79	;"y"
	CALL	ZNAK
	MOVLW	43	;"C"
	CALL	ZNAK
	MOVLW	6F	;"o"
	CALL	ZNAK
	MOVLW	75	;"u"
	CALL	ZNAK
	MOVLW	6E	;"n"
	CALL	ZNAK
	MOVLW	74	;"t"
	CALL	ZNAK
	MOVLW	65	;"e"
	CALL	ZNAK
	MOVLW	72	;"r"
	CALL	ZNAK
	MOVLW	0C0	;naslov LCD zacetek druge vrstice
	CALL	UKAZ
	MOVLW	53	;"S" - S53MV
	CALL	ZNAK
	MOVLW	35	;"5"
	CALL	ZNAK
	MOVLW	33	;"3"
	CALL	ZNAK
	MOVLW	4D	;"M"
	CALL	ZNAK
	MOVLW	56	;"V"
	CALL	ZNAK
	MOVLW	20	;" "
	CALL	ZNAK
	MOVLW	30	;"0" - 05.05.2007
	CALL	ZNAK
	MOVLW	35	;"5"
	CALL	ZNAK
	MOVLW	2E	;"."
	CALL	ZNAK
	MOVLW	30	;"0"
	CALL	ZNAK
	MOVLW	35	;"5"
	CALL	ZNAK
	MOVLW	2E	;"."
	CALL	ZNAK
	MOVLW	32	;"2"
	CALL	ZNAK
	MOVLW	30	;"0"
	CALL	ZNAK
	MOVLW	30	;"0"
	CALL	ZNAK
	MOVLW	37	;"7"
	CALL	ZNAK
	MOVLW	0FA	;cakanje priblizno 1s
	MOVWF	21
NAPIS1	CALL	CAKAJ40
	CALL	MERIF	;merjenje frekvence
	DECFSZ	21,1
	GOTO	NAPIS1
	RETURN

;*** Vpisi posebne znake v CGRAM ***
CGRAM	MOVLW	40	;naslov za CGRAM
	CALL	UKAZ 
	MOVLW	10	;ena pokoncna crtica v desno - 0
	CALL	ZNAK
	MOVLW	10
	CALL	ZNAK
	MOVLW	10
	CALL	ZNAK
	MOVLW	10
	CALL	ZNAK
	MOVLW	10
	CALL	ZNAK
	MOVLW	10
	CALL	ZNAK
	MOVLW	10
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	14	;dve pokoncni crtici v desno - 1
	CALL	ZNAK
	MOVLW	14
	CALL	ZNAK
	MOVLW	14
	CALL	ZNAK
	MOVLW	14
	CALL	ZNAK
	MOVLW	14
	CALL	ZNAK
	MOVLW	14
	CALL	ZNAK
	MOVLW	14
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	15	;tri pokoncne crtice - 2
	CALL	ZNAK
	MOVLW	15
	CALL	ZNAK
	MOVLW	15
	CALL	ZNAK
	MOVLW	15
	CALL	ZNAK
	MOVLW	15
	CALL	ZNAK
	MOVLW	15
	CALL	ZNAK
	MOVLW	15
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F	;ena pokoncna crtica dol - 3
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F	;dve pokoncni crtici dol - 4
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F	;tri pokoncne crtice dol - 5
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F	;stiri pokoncne crtice dol - 6
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F	;pet pokoncnih crtic dol - 7
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F
	CALL	ZNAK
	MOVLW	0
	CALL	ZNAK
	MOVLW	1F
	CALL	ZNAK
	MOVLW	1F
	CALL	ZNAK
	RETURN

;*** Inicializacija HD44780 ***
INILCD	MOVLW	38	;function set 
	CALL	UKAZ
	CALL	CAKAJ40
	MOVLW	38	;function set
	CALL	UKAZ
	MOVLW	38	;function set
	CALL	UKAZ
	MOVLW	8	;display off
	CALL	UKAZ
	MOVLW	1	;display clear
	CALL	UKAZ
	CALL	CAKAJ40
	MOVLW	6	;entry mode set
	CALL	UKAZ
	MOVLW	0C	;display on
	CALL	UKAZ
	CALL	CGRAM	;vpisi posebne znake v CGRAM
	RETURN

;*** Cakaj priblizno 100us (takt 20MHz) ***
CAKAJP	MOVLW	7C
CAKAJP1	ADDLW	0FF	;zanka 4 ukazi
	BTFSS	3,2
	GOTO	CAKAJP1
	RETURN

;*** Cakanje 4ms *** (20)
CAKAJ40	MOVLW	28
	MOVWF	20
CAKAJ41	CALL	CAKAJP
	DECFSZ	20,1
	GOTO	CAKAJ41
	RETURN

;*** Znak ali ukaz iz W v HD44780 ***
ZNAK	BSF	7,6	;postavi RC6 RS=1 za znak
	GOTO	ZNUKAZ
UKAZ	BCF	7,6	;postavi RC6 RS=0 za ukaz
ZNUKAZ	MOVWF	6	;premakni bajt podatkov v RB0-7
	NOP
	NOP
	NOP
	NOP
	BSF	7,7	;impulz E na RC7
	NOP
	NOP
	NOP
	NOP
	BCF	7,7
	CALL	CAKAJP	;cakanje 100us
	RETURN

;*** Nastavi konfiguracijo PICa 16F876/16F876A ***
	ORG	2007	;naslov konfiguracijske besede
	DW	3972	
;3: 11=/CP=off
;9: 1=/DEBUG=off, 00=WRT10=off, 1=/CPD=off 
;7: 0=LVP, 1=BODEN=on, 11=/CP=off
;2: 0=/PWRTE=on, 0=WDTE=off, 10=HSoscillator
	END

;*** Konec programa ***
